package com.muyu.vehicle.service;

import com.aliyun.ecs20140526.Client;
import com.aliyun.ecs20140526.models.DescribeInstancesRequest;
import com.aliyun.ecs20140526.models.DescribeInstancesResponse;
import com.aliyun.ecs20140526.models.DescribeInstancesResponseBody;
import com.aliyun.teaopenapi.models.Config;
import com.aliyun.teautil.Common;
import com.aliyun.teautil.models.RuntimeOptions;
import com.muyu.vehicle.domain.InstanceInfo;
import lombok.extern.log4j.Log4j2;

import java.util.ArrayList;

@Log4j2
public class SelectInstance {
    /**
     * ACCESS_KEY_ID
     */
    public static final String ALIBABA_CLOUD_ACCESS_KEY_ID="LTAI5tGabdxedjfCh2uXHNrw";

    /**
     *ACCESS_KEY_SECRET
     */
    public static final String ACCESS_KEY_SECRET="NHb7wHVpesLW6Axc0bFBs6ThhuNR10";

    public static Client createClient(String accessKeyId, String accessKeySecret) throws Exception {
        Config config = new com.aliyun.teaopenapi.models.Config()
                // 必填，您的 AccessKey ID
                .setAccessKeyId(ALIBABA_CLOUD_ACCESS_KEY_ID)
                // 必填，您的 AccessKey Secret
                .setAccessKeySecret(ACCESS_KEY_SECRET);
        // 访问的域名
        config.endpoint = "ecs-cn-hangzhou.aliyuncs.com";
        return new Client(config);
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        // 请确保代码运行环境设置了环境变量 ALIBABA_CLOUD_ACCESS_KEY_ID 和 ALIBABA_CLOUD_ACCESS_KEY_SECRET。
        // 工程代码泄露可能会导致 AccessKey 泄露，并威胁账号下所有资源的安全性。以下代码示例仅供参考，建议使用更安全的 STS 方式
         Client client = SelectInstance.createClient(ALIBABA_CLOUD_ACCESS_KEY_ID, ACCESS_KEY_SECRET);
         DescribeInstancesRequest describeInstancesRequest = new DescribeInstancesRequest()
                .setRegionId("cn-shanghai")
                .setInternetChargeType("PayByTraffic")
                .setInstanceChargeType("PostPaid")
                 .setInstanceName("cloud-MQTT") // 设置实例名称
                 ;
         //实例ID Instances.Instance.InstanceId
        //实例IP Instances.Instance.PublicIpAddress.IpAddress
        //状态 Instances.Instance.Status
        RuntimeOptions runtime = new RuntimeOptions();
        DescribeInstancesResponse resp = client.describeInstancesWithOptions(describeInstancesRequest, runtime);
        DescribeInstancesResponseBody body = resp.getBody();
        ArrayList<InstanceInfo> instanceInfos = new ArrayList<>();// 实例基础信息
        for (DescribeInstancesResponseBody.DescribeInstancesResponseBodyInstancesInstance instance : body.getInstances().getInstance()){

            InstanceInfo instanceInfo = new InstanceInfo();
            instanceInfo.setInstanceId(instance.getInstanceId());
            instanceInfo.setIpAddress(String.valueOf(instance.getPublicIpAddress().getIpAddress()));
            instanceInfo.setStatus(instance.getStatus());
            instanceInfos.add(instanceInfo);
        }
        log.info(Common.toJSONString(instanceInfos));
    }
}
